package torneio;

import java.util.ArrayList;
import java.util.Collections;

public class ExecutaTorneio {

	public static void main (String args[]){
		Partida.LOG = true;
		int NUMERO_DE_PARTIDAS = 101;
		if (args.length>0) NUMERO_DE_PARTIDAS = Integer.parseInt(args[0]);
		System.out.println("Bem Vindo ao Torneio de Truco");
		Jogador[] jogadores = new Jogador[2];
		int[] vitoriasPartidas = new int[jogadores.length];
		int[] vitoriasAbsolutas = new int[jogadores.length];
		jogadores[0] = new JogadorExemplo1();
		jogadores[1] = new JogadorExemplo2();
		int partidas = 0;
		int duelos = 0;
		Time timeQueComeca = Time.Time1;
		

		for (int i=0;i<jogadores.length;i++){
			for (int j=i+1;j<jogadores.length;j++){
				int[] vitoriasTemp = new int[2];
				duelos++;
				
				System.out.print("\n### Iniciando duelo: "+ jogadores[i].nomeDoJogador() + " x " + jogadores[j].nomeDoJogador());
				
				for (int x=0;x<NUMERO_DE_PARTIDAS;x++){
					partidas++;
					Partida novaPartida = new Partida(jogadores[i],jogadores[j], Time.Time1);
					if (novaPartida.getPlacarTime1() > novaPartida.getPlacarTime2()) vitoriasTemp[0]++;
					else vitoriasTemp[1]++;
					
					if (timeQueComeca==Time.Time1) timeQueComeca = Time.Time2;
					else timeQueComeca = Time.Time1;
				}
				System.out.println("\nVitorias do Time1 (" + jogadores[i].nomeDoJogador()+"): " + vitoriasTemp[0]);
				System.out.println("Vitorias do Time2 (" + jogadores[j].nomeDoJogador()+"): " + vitoriasTemp[1]);
				vitoriasPartidas[i] += vitoriasTemp[0];
				vitoriasPartidas[j] += vitoriasTemp[1];
				if (vitoriasTemp[0]>vitoriasTemp[1]) vitoriasAbsolutas[i]++;
				else if (vitoriasTemp[0]<vitoriasTemp[1]) vitoriasAbsolutas[j]++;
			}
		}
		System.out.println("\n");
		System.out.println("Duelos realizados: " + duelos +". Partidas realizadas: " + partidas+".\n");
		ArrayList<Placar> resultados = new ArrayList<Placar>();
		for (int i=0;i<jogadores.length;i++){
			double porc = (int)(0.5+(double)10000*vitoriasPartidas[i]/(NUMERO_DE_PARTIDAS*(jogadores.length-1)));
			porc = (porc)/100;
			resultados.add(new Placar(jogadores[i].nomeDoJogador(),porc,vitoriasAbsolutas[i]));
			//System.out.println("Vitorias do Time '" + jogadores[i].nomeDoJogador()+"': " + porc +"% (partidas);  " + vitoriasAbsolutas[i] + " vitoria(s).");
		}		

		//ArrayList<Placar> temp = ;
		Collections.sort(resultados);
		for (int i=0;i<jogadores.length;i++){
			System.out.println("Vitorias do Time '" + resultados.get(i).time+"': " + resultados.get(i).partidas +"% (partidas);  " + resultados.get(i).vitorias + " vitoria(s).");
		}		
		
	}
	
}
