package torneio;

import java.util.Random;

public class JogadorExemplo2 implements Jogador{

	public Jogada aceitaAumento(LogAtualDoJogo estadoDoJogo) {
		Random rand = new Random();
		int teste = rand.nextInt(100);
		if (teste < 45) return Jogada.AbandonarRodada;
		else if (teste>=45 && teste<90){
			return Jogada.AceitarAumento;
		}
		if (estadoDoJogo.getValorAtualDaRodada()>=9) return Jogada.AceitarAumento;
		return Jogada.SolicitarAumento;
	}

	public boolean aceitaMaoDeOnze(LogAtualDoJogo estadoDoJogo) {
		Random rand = new Random();
		int teste = rand.nextInt(100);
		if (teste < 90) return true;
		return false;
	}

	public Jogada jogar(LogAtualDoJogo estadoDoJogo) {
		Carta[] cartasNaMao;
		int valores = 0;
		cartasNaMao = estadoDoJogo.getCartasNaSuaMao();
		for (int i=0;i<cartasNaMao.length;i++){
			valores+=cartasNaMao[i].getValor();
		}
		if (valores>0) valores=valores/cartasNaMao.length;
		
		if (valores >= 6 && estadoDoJogo.getValorAtualDaRodada()<3 && estadoDoJogo.getPlacarDoAdversario() <11 && estadoDoJogo.getSeuPlacar()<11 && !estadoDoJogo.isFuiOUltimoAAumentar()) {
			return Jogada.SolicitarAumento;
	    }
		
		if (estadoDoJogo.isAdversarioJaJogouNestaRodada()){
			int rodadaAtual = estadoDoJogo.getNumeroRodadaAtual();
			int valorDaCartaDoAdv = estadoDoJogo.getCartasJogadasPeloAdversario()[rodadaAtual-1].getValor();
			for (int i=0;i<cartasNaMao.length;i++){
				if (cartasNaMao[i].getValor() > valorDaCartaDoAdv){
					if (i==0) return Jogada.JogarCarta1;
					else if (i==1) return Jogada.JogarCarta2;
					else if (i==2) return Jogada.JogarCarta3;
				}
			}	
		}else{
			Random rand = new Random();
			int i = rand.nextInt(cartasNaMao.length);
			if (i==0) return Jogada.JogarCarta1;
			else if (i==1) return Jogada.JogarCarta2;
			else if (i==2) return Jogada.JogarCarta3;
		}
		return Jogada.JogarCarta1;
	}

	public String nomeDoJogador() {
		return "Exemplo2";
	}

}
