package torneio;

public class CartasNaMao {
	private Carta[] cartas;
	private int quantidadeDeCartas;
	public CartasNaMao(Carta[] pCartas){
		cartas = pCartas;
		quantidadeDeCartas = cartas.length;  
	}
	
	public Carta[] getCartas(){
		Carta[] resultado = new Carta[quantidadeDeCartas];
		for (int i=0;i<quantidadeDeCartas;i++){
			resultado[i] = cartas[i].Clone();
		}
		return resultado;
	}
	
	public boolean removerCarta(int indice){
		if (indice >-1 && indice < quantidadeDeCartas){
			Carta[] resultado = new Carta[quantidadeDeCartas-1];
			int diferenca = 0;
			for (int i=0;i<quantidadeDeCartas;i++){
				if (indice == i) diferenca = 1;
				else{
					resultado[i-diferenca] = cartas[i].Clone();
				}
			}
			cartas = resultado;
			quantidadeDeCartas--;
			return true;
		}else{
			return false;
		}
	}
	
}
