package torneio;


public class LogAtualDoJogo {
	private int seuPlacar;
	private int placarDoAdversario;
	private int numeroDaRodadaAtual;
	private Carta[] cartasNaSuaMao;
	private Carta[] cartasJogadasPorVoce;
	private Carta[] cartasJogadasPeloAdversario;
	private boolean adversarioJaJogouNestaRodada;
	private boolean fuiOUltimoAAumentar = false;
	private int valorAtualDaRodada;
	private int numeroDaMaoAtual;
	private int quantidadeDeVezesQueAdversarioAumentou;
	private int quantidadeDeVezesQueVoceAumentou;
	private int quantidadeDeVezesQueAdversarioAceitouAumento;
	private boolean euComecoEstaMao = false;

	public LogAtualDoJogo(int pontos1, int pontos2, int numRodada, Carta[] suasCartas, Carta[] cartasVoceJogou, Carta[] cartasQueOAdversarioJogou, boolean adversarioJogou, boolean euAumentei, int valorAtual, int maoAtual, int numAdversarioAumentou, int numVoceAumentou, int numAdversarioAceitou, boolean euComecoAMao){
		seuPlacar = pontos1;
		placarDoAdversario = pontos2;
		numeroDaRodadaAtual = numRodada;
		cartasNaSuaMao = suasCartas;
		cartasJogadasPorVoce = cartasVoceJogou;
		cartasJogadasPeloAdversario = cartasQueOAdversarioJogou;
		adversarioJaJogouNestaRodada = adversarioJogou;
		fuiOUltimoAAumentar = euAumentei;
		valorAtualDaRodada = valorAtual;
		numeroDaMaoAtual = maoAtual;		
		quantidadeDeVezesQueAdversarioAumentou = numAdversarioAumentou;
		quantidadeDeVezesQueVoceAumentou = numVoceAumentou;
		quantidadeDeVezesQueAdversarioAceitouAumento = numAdversarioAceitou;
		euComecoEstaMao = euComecoAMao;
	}

	protected int getSeuPlacar() {
		return seuPlacar;
	}

	protected int getPlacarDoAdversario() {
		return placarDoAdversario;
	}

	protected int getNumeroRodadaAtual() {
		return numeroDaRodadaAtual;
	}

	protected Carta[] getCartasNaSuaMao() {
		return cartasNaSuaMao.clone();
	}

	protected Carta[] getCartasJogadasPorVoce() {
		return cartasJogadasPorVoce;
	}

	protected Carta[] getCartasJogadasPeloAdversario() {
		return cartasJogadasPeloAdversario;
	}

	protected boolean isAdversarioJaJogouNestaRodada() {
		return adversarioJaJogouNestaRodada;
	}

	protected int getValorAtualDaRodada() {
		return valorAtualDaRodada;
	}

	protected int getNumeroDaMaoAtual() {
		return numeroDaMaoAtual;
	}

	protected int getQuantidadeDeVezesQueAdversarioAumentou() {
		return quantidadeDeVezesQueAdversarioAumentou;
	}

	protected int getQuantidadeDeVezesQueVoceAumentou() {
		return quantidadeDeVezesQueVoceAumentou;
	}

	protected int getQuantidadeDeVezesQueAdversarioAceitouAumento() {
		return quantidadeDeVezesQueAdversarioAceitouAumento;
	}

	protected boolean isFuiOUltimoAAumentar() {
		return fuiOUltimoAAumentar;
	}

	protected boolean isEuComecoEstaMao() {
		return euComecoEstaMao;
	}
	
}
