package torneio;

public class Mao {
	public static boolean LOG = false;
	private Jogador j1;
	private Jogador j2;
	private Time timeQueComecaAMao;
	private int placarTime1;
	private int placarTime2;
	private Carta[] cartas;
	private int pontosDaRodadaTime1=0;
	private int pontosDaRodadaTime2=0;
	// LOG
	private int numeroDaMaoAtual;
	private int[] quantidadeDeVezesQueJogadorAumentou = new int[2];
	private int[] quantidadeDeVezesQueJogadorAceitou = new int[2];
	
	
	public Mao(Jogador pJ1, Jogador pJ2, Time quemComeca,int pPlacarTime1,int pPlacarTime2, Carta[] pCartas, int maoAtual, int[] numJogAumentou, int[] numJogAceitou){
		j1 = pJ1;
		j2 = pJ2;
		timeQueComecaAMao = quemComeca;
		placarTime1 = pPlacarTime1;
		placarTime2 = pPlacarTime2;
		cartas = pCartas;

		numeroDaMaoAtual = maoAtual;		
		quantidadeDeVezesQueJogadorAumentou = numJogAumentou;
		quantidadeDeVezesQueJogadorAceitou = numJogAceitou;
	}
	
	public int[] executarMao(){
		Rodadas.LOG = LOG;
		boolean perguntarMaoDeOnze1 = false;
		boolean perguntarMaoDeOnze2 = false;
		if (placarTime1+placarTime2 == 22){
		}else if (placarTime1==11){
			perguntarMaoDeOnze1 = true;
		}else if (placarTime2==11){
			perguntarMaoDeOnze2 = true;
		}
		int[] resultado = new int[2];
		resultado[0] = pontosDaRodadaTime1;
		resultado[1] = pontosDaRodadaTime2;

		Jogador[] jogs = new Jogador[2];
		jogs[0] = j1;
		jogs[1] = j2;
		LogInterno estadoDoJogo = new LogInterno(placarTime1,placarTime2, cartas, false, timeQueComecaAMao, 1,numeroDaMaoAtual,quantidadeDeVezesQueJogadorAumentou,quantidadeDeVezesQueJogadorAceitou);
		if (LOG) estadoDoJogo.imprimir();
		if (perguntarMaoDeOnze1) if (j1.aceitaMaoDeOnze(estadoDoJogo.gerarLogEspecifico(Time.Time1))){
			if (LOG) System.out.println("  =Aceitou mao de 11  " + Time.Time1.toString());
			estadoDoJogo.valorAtualDaRodada = 3;
		}else{
			if (LOG) System.out.println("  =Nao aceitou mao de 11  " + Time.Time1.toString());
			resultado[1] = 1;
			return resultado;
		}
		if (perguntarMaoDeOnze2) if (j2.aceitaMaoDeOnze(estadoDoJogo.gerarLogEspecifico(Time.Time2))){
			if (LOG) System.out.println("  =Aceitou mao de 11  " + Time.Time2.toString());
			estadoDoJogo.valorAtualDaRodada = 3;
		}else{
			if (LOG) System.out.println("  =Nao aceitou mao de 11  " + Time.Time2.toString());
			resultado[0] = 1;
		}
		return Rodadas.executarRodadas(jogs, estadoDoJogo);
		
	}
}
