package torneio;

public class Partida {
	public static boolean LOG = false;
	private int placarTime1;
	private int placarTime2;
	private int[] quantidadeDeVezesQueJogadorAumentou = new int[2];
	private int[] quantidadeDeVezesQueJogadorAceitou = new int[2];
    private int maoAtual = 1;
	public Partida(Jogador j1, Jogador j2, Time quemComecaPrimeiraMao){
		placarTime1 = 0;
		placarTime2 = 0;
		Time quemComecaMao = quemComecaPrimeiraMao;
		Baralho b1 = new Baralho();
		Mao.LOG = LOG;
		while (placarTime1 < 12 && placarTime2<12){
			Mao mao = new Mao(j1,j2,quemComecaMao,placarTime1,placarTime2,b1.darAsCartas(6),maoAtual,quantidadeDeVezesQueJogadorAumentou,quantidadeDeVezesQueJogadorAceitou);
			int[] res = mao.executarMao();
			maoAtual++;
			placarTime1 += res[0];
			placarTime2 += res[1];

			if (quemComecaMao == Time.Time1){
				quemComecaMao = Time.Time2;
			}else quemComecaMao = Time.Time1;
		}
		if (LOG) System.out.println("$ Placar: " +placarTime1 + " x " + placarTime2 + " $");
		
	}
	protected int getPlacarTime1() {
		return placarTime1;
	}
	protected int getPlacarTime2() {
		return placarTime2;
	}
	
}